<template>
  <v-dialog
    v-model="isOpen"
    max-width="800px"
    :fullscreen="$vuetify.breakpoint.xsOnly"
    :transition="$vuetify.breakpoint.xsOnly ? 'dialog-bottom-transition' : 'dialog-transition'"
    scrollable
  >
    <v-card :tile="$vuetify.breakpoint.smAndDown">
      <v-card-title>
        {{ $t('courses.description.version.revision_nr') }} {{ version.number }}

        <v-spacer />

        <!-- Close -->
        <v-btn icon @click="isOpen = false">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-card-title>

      <!-- Reverted from -->
      <v-card-subtitle v-if="version.revertedVersion">
        <span>{{ $t('courses.description.version.reverted') }} {{ version.revertedVersion.number }}</span>
      </v-card-subtitle>

      <!-- Content -->
      <v-card-text>
        <!-- Error Handling -->
        <suspense-mutation
          :mutation="revertDescriptionMutation"
          transition="slide-y-transition"
          transition-mode="out-in"
        >
          <template #error>
            <v-alert class="studium-alert" dense text type="error">
              {{ revertDescriptionMutationError.message }}
            </v-alert>
          </template>
        </suspense-mutation>

        <!-- Version -->
        <suspense-query :query="versionDescriptionQuery" :delay-loading="500">
          <!-- Loading -->
          <template #loading>
            <page-loader />
          </template>

          <!-- Error -->
          <template #error>
            <page-error :error="versionDescriptionQueryError" />
          </template>

          <!-- Data -->
          <template #data>
            <div v-dompurify-html="versionDescription" />
          </template>
        </suspense-query>
      </v-card-text>

      <!-- actions -->
      <v-card-actions>
        <v-spacer />

        <!-- Revert -->
        <v-tooltip bottom>
          <template #activator="{ on, attrs }">
            <div v-bind="attrs" v-on="on">
              <v-btn
                class="studium-button"
                color="primary"
                text
                :ripple="false"
                :loading="revertDescriptionMutation.loading.value"
                @click="onRevert"
              >
                {{ $t('courses.description.version.revert') }}
                {{ $vuetify.breakpoint.smAndUp ? 'to this revision' : '' }}
              </v-btn>
            </div>
          </template>

          <!-- Tooltip -->
          <span> {{ $t('courses.description.version.tooltip') }} </span>
        </v-tooltip>

        <!-- Close -->
        <v-btn class="studium-button" color="secondary" text :ripple="false" @click="isOpen = false">
          {{ $t('courses.description.version.close') }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import { computed, defineComponent } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'

import { useCourseDescriptionVersionContentQuery, useRevertCourseDescriptionMutation } from '~/apollo/_generated'
import { useErrorHandler } from '~/util/composables/'

export default defineComponent({
  props: {
    // Synchronised property if the dialog is open
    open: {
      type: Boolean,
      default: false,
    },

    // Version to show
    version: {
      type: Object,
      required: true,
    },

    // Course code of the course that contains the version
    courseCode: {
      type: String,
      required: true,
    },
  },
  setup(props, { emit }) {
    const isOpen = useVModel(props, 'open', emit)

    // Version info
    const versionDescriptionQuery = useCourseDescriptionVersionContentQuery(
      { id: props.version.id },
      { fetchPolicy: 'no-cache' }
    )
    const versionDescriptionQueryError = useErrorHandler(versionDescriptionQuery)
    const versionDescription = computed(
      () => versionDescriptionQuery.result.value?.courseDescriptionVersionById?.content ?? []
    )

    // Revert to this revision mutation
    const revertDescriptionMutation = useRevertCourseDescriptionMutation({})
    const revertDescriptionMutationError = useErrorHandler(revertDescriptionMutation)

    function onRevert() {
      // Attempt to revert the content
      revertDescriptionMutation.mutate({
        code: props.courseCode,
        revertVersionId: props.version.id,
      })
    }

    // Close the model when the revert is done
    revertDescriptionMutation.onDone(() => {
      // Emit success
      emit('success', `Successfully reverted to revision ${props.version.number}`)

      // Close the dialog
      isOpen.value = false
    })

    return {
      isOpen,
      versionDescriptionQuery,
      versionDescriptionQueryError,
      versionDescription,
      revertDescriptionMutation,
      revertDescriptionMutationError,
      onRevert,
    }
  },
})
</script>
